var RnaQcImport = function()
{
	var rnaqc = {};
	var debug = 0;
	
	// Page initialization
	rnaqc.initPage = function()
	{
		// Step 1
		Wizard.initFileSelectionField('csv');
		Wizard.initFileSelectionField('gxdstd');
		Wizard.initFileSelectionField('gxdhi');
		Wizard.initFileSelectionField('pdf');
		Events.addEventHandler('csv', 'change', rnaqc.preValidateCsvFile);
		Events.addEventHandler('qcRunDate', 'change', Wizard.validateDate);
		Events.addEventHandler('step-1', 'wizard-validate', rnaqc.validateStep1);
		Events.addEventHandler('bioplate.name', 'click', rnaqc.bioplateOnClick);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', rnaqc.submit);

		var frm = document.forms['reggie'];
		frm.csv.focus();
		Doc.show('step-1');
		Doc.show('goregister');
	}
	
	rnaqc.preValidateCsvFile = function(event)
	{
		var frm = document.forms['reggie'];
		var csv = frm.csv.value;
		if (!csv) return;
		
		Doc.element('bioplate.name').innerHTML = '<i>no bioplate</i>';
		Data.set('bioplate.name', 'item-id', 0);
		Doc.removeClass('bioplate.name', 'link');
		Wizard.setInputStatus('csv', 'checking', 'Checking...');
		
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=PreValidateCaliperResults&csv='+encodeURIComponent(csv);
		Wizard.asyncJsonRequest(url, rnaqc.onCsvValidated, 'POST');
	}

	rnaqc.onCsvValidated = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.setInputStatus('csv');
		Wizard.showFinalMessage(response.messages);

		if (!response.valid)
		{
			Wizard.setInputStatus('csv', 'invalid');
			Data.set('csv', 'valid', 0);
			return;
		}

		Wizard.setInputStatus('csv', response.warnings > 0 ? 'warning' : 'valid');
		Data.set('csv', 'valid', 1);
		
		
		var bioplate = response.plate;
		
		Doc.element('bioplate.name').innerHTML = Strings.encodeTags(bioplate.name);
		Data.set('bioplate.name', 'item-id', bioplate.id);
		Doc.addClass('bioplate.name', 'link');
		
		Wizard.setInputStatus('bioplate', 'valid');
		if (bioplate.QCRunDate)
		{
			frm.qcRunDate.value = bioplate.QCRunDate;
			Events.sendChangeEvent('qcRunDate');
			Wizard.setInputStatus('bioplate', 'warning', 'Data has already been imported to this plate');
		}
		else
		{
			// Try to get date from the filename
			var dates = frm.csv.value.match(/\d\d\d\d-\d\d-\d\d/);
			if (dates && dates.length >= 1)
			{
				var date = dates[0];
				frm.qcRunDate.value = date.substr(0, 4)+date.substr(5, 2)+date.substr(8, 2);
				Events.sendChangeEvent('qcRunDate');
			}
		}
		
		if (bioplate.QCOperator)
		{
			frm.qcOperator.value = bioplate.QCOperator;	
		}
		
	}

	rnaqc.bioplateOnClick = function()
	{
		var plateId = Data.int('bioplate.name', 'item-id');
		if (!plateId) return;
		Items.viewItem('BIOPLATE', plateId);
	}
	
	rnaqc.validateStep1 = function(event)
	{
		var valid = true;
		
		valid &= Wizard.isValid('csv');
		valid &= Wizard.isValid('qcRunDate');

		if (!valid) event.preventDefault();
	}

	rnaqc.submit = function()
	{
		Doc.hide('wizard-status');
		var frm = document.forms['reggie'];
			
		var submitInfo = {};
		submitInfo.csv = frm.csv.value;
		submitInfo.gxdStd = frm.gxdstd.value;
		submitInfo.gxdHi = frm.gxdhi.value;
		submitInfo.pdf = frm.pdf.value;
		submitInfo.QCRunDate = frm.qcRunDate.value;
		submitInfo.QCOperator = frm.qcOperator.value;
			
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportCaliperResults';
			
		Wizard.showLoadingAnimation('Importing RQS values...');
		Wizard.asyncJsonRequest(url, rnaqc.submissionResults, 'POST', JSON.stringify(submitInfo));
	}

	rnaqc.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}
	
	return rnaqc;
}();

Doc.onLoad(RnaQcImport.initPage);

